searchNodes=[{"doc":"Documentation for Premailex.","ref":"Premailex.html","title":"Premailex","type":"module"},{"doc":"Adds inline styles to an HTML string.Examplesiex&gt; Premailex.to_inline_css(&quot;&lt;html&gt;&lt;head&gt;&lt;style&gt;p{background-color: #fff;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;p style=\\&quot;color: #000;\\&quot;&gt;Text&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;&quot;) &quot;&lt;html&gt;&lt;head&gt;&lt;style&gt;p{background-color: #fff;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;p style=\\&quot;background-color:#fff;color:#000;\\&quot;&gt;Text&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;&quot;","ref":"Premailex.html#to_inline_css/2","title":"Premailex.to_inline_css/2","type":"function"},{"doc":"Turns an HTML string into text.Examplesiex&gt; Premailex.to_text(&quot;&lt;html&gt;&lt;head&gt;&lt;style&gt;p{background-color:#fff;}&lt;/style&gt;&lt;/head&gt;&lt;body&gt;&lt;p style=\\&quot;color:#000;\\&quot;&gt;Text&lt;/p&gt;&lt;/body&gt;&lt;/html&gt;&quot;) &quot;Text&quot;","ref":"Premailex.html#to_text/1","title":"Premailex.to_text/1","type":"function"},{"doc":"Module that handles CSS parsing with naive Regular Expression.","ref":"Premailex.CSSParser.html","title":"Premailex.CSSParser","type":"module"},{"doc":"Merges CSS rules.Examplesiex&gt; rule_sets = Premailex.CSSParser.parse(&quot;p {background-color: #fff !important; color: #000;} p {background-color: #000;}&quot;) iex&gt; Premailex.CSSParser.merge(rule_sets) [%{directive: &quot;background-color&quot;, value: &quot;#fff !important&quot;, important?: true, specificity: 1}, %{directive: &quot;color&quot;, value: &quot;#000&quot;, important?: false, specificity: 1}]","ref":"Premailex.CSSParser.html#merge/1","title":"Premailex.CSSParser.merge/1","type":"function"},{"doc":"Parses a CSS string into a map.Examplesiex&gt; Premailex.CSSParser.parse(&quot;body { background-color: #fff !important; color: red; }&quot;) [%{rules: [%{directive: &quot;background-color&quot;, value: &quot;#fff !important&quot;, important?: true}, %{directive: &quot;color&quot;, value: &quot;red&quot;, important?: false}], selector: &quot;body&quot;, specificity: 1}]","ref":"Premailex.CSSParser.html#parse/1","title":"Premailex.CSSParser.parse/1","type":"function"},{"doc":"Parses a CSS rules string into a map.Note: parse_rules/1 won't strip any CSS comments unlike parse/1.Examplesiex&gt; Premailex.CSSParser.parse_rules(&quot;background-color: #fff; color: red;&quot;) [%{directive: &quot;background-color&quot;, value: &quot;#fff&quot;, important?: false}, %{directive: &quot;color&quot;, value: &quot;red&quot;, important?: false}]","ref":"Premailex.CSSParser.html#parse_rules/1","title":"Premailex.CSSParser.parse_rules/1","type":"function"},{"doc":"Transforms CSS map or list into string.Examplesiex&gt; Premailex.CSSParser.to_string([%{directive: &quot;background-color&quot;, value: &quot;#fff&quot;}, %{directive: &quot;color&quot;, value: &quot;#000&quot;}]) &quot;background-color:#fff;color:#000;&quot; iex&gt; Premailex.CSSParser.to_string(%{directive: &quot;background-color&quot;, value: &quot;#fff&quot;}) &quot;background-color:#fff;&quot;","ref":"Premailex.CSSParser.html#to_string/1","title":"Premailex.CSSParser.to_string/1","type":"function"},{"doc":"","ref":"Premailex.CSSParser.html#t:rule/0","title":"Premailex.CSSParser.rule/0","type":"type"},{"doc":"","ref":"Premailex.CSSParser.html#t:rule_set/0","title":"Premailex.CSSParser.rule_set/0","type":"type"},{"doc":"Module that processes inline styling in HMTL.","ref":"Premailex.HTMLInlineStyles.html","title":"Premailex.HTMLInlineStyles","type":"module"},{"doc":"Processes an HTML string adding inline styles.Options::css_selector - the style tags to be processed for inline styling, defaults to style,link[rel=&quot;stylesheet&quot;][href]:optimize - list or atom option for optimizing the output. The following values can be used::none - no optimization (default):all - apply all optimization steps:remove_style_tags - Remove style tags (can be combined in a list)","ref":"Premailex.HTMLInlineStyles.html#process/3","title":"Premailex.HTMLInlineStyles.process/3","type":"function"},{"doc":"Module that provide HTML parsing API using an underlying HTML parser library.","ref":"Premailex.HTMLParser.html","title":"Premailex.HTMLParser","type":"behaviour"},{"doc":"Searches an HTML tree for the selector.Examplesiex&gt; Premailex.HTMLParser.all({&quot;html&quot;, [], [{&quot;head&quot;, [], []}, {&quot;body&quot;, [], [{&quot;h1&quot;, [], [&quot;Title&quot;]}]}]}, &quot;h1&quot;) [{&quot;h1&quot;, [], [&quot;Title&quot;]}]","ref":"Premailex.HTMLParser.html#all/2","title":"Premailex.HTMLParser.all/2","type":"function"},{"doc":"","ref":"Premailex.HTMLParser.html#c:all/2","title":"Premailex.HTMLParser.all/2","type":"callback"},{"doc":"Filters elements matching the selector from the HTML tree.Examplesiex&gt; Premailex.HTMLParser.filter([{&quot;html&quot;, [], [{&quot;head&quot;, [], []}, {&quot;body&quot;, [], [{&quot;h1&quot;, [], [&quot;Title&quot;]}]}]}], &quot;h1&quot;) [{&quot;html&quot;, [], [{&quot;head&quot;, [], []}, {&quot;body&quot;, [], []}]}]","ref":"Premailex.HTMLParser.html#filter/2","title":"Premailex.HTMLParser.filter/2","type":"function"},{"doc":"","ref":"Premailex.HTMLParser.html#c:filter/2","title":"Premailex.HTMLParser.filter/2","type":"callback"},{"doc":"Parses a HTML string into an HTML tree.Examplesiex&gt; Premailex.HTMLParser.parse(&quot;&lt;html&gt;&lt;head&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Title&lt;/h1&gt;&lt;/body&gt;&lt;/html&gt;&quot;) {&quot;html&quot;, [], [{&quot;head&quot;, [], []}, {&quot;body&quot;, [], [{&quot;h1&quot;, [], [&quot;Title&quot;]}]}]}","ref":"Premailex.HTMLParser.html#parse/1","title":"Premailex.HTMLParser.parse/1","type":"function"},{"doc":"","ref":"Premailex.HTMLParser.html#c:parse/1","title":"Premailex.HTMLParser.parse/1","type":"callback"},{"doc":"Extracts text elements from the HTML tree.Examplesiex&gt; Premailex.HTMLParser.text({&quot;html&quot;, [], [{&quot;head&quot;, [], []}, {&quot;body&quot;, [], [{&quot;h1&quot;, [], [&quot;Title&quot;]}]}]}) &quot;Title&quot;","ref":"Premailex.HTMLParser.html#text/1","title":"Premailex.HTMLParser.text/1","type":"function"},{"doc":"","ref":"Premailex.HTMLParser.html#c:text/1","title":"Premailex.HTMLParser.text/1","type":"callback"},{"doc":"Turns an HTML tree into a string.Examplesiex&gt; Premailex.HTMLParser.to_string({&quot;html&quot;, [], [{&quot;head&quot;, [], []}, {&quot;body&quot;, [], [{&quot;h1&quot;, [], [&quot;Title&quot;]}]}]}) &quot;&lt;html&gt;&lt;head&gt;&lt;/head&gt;&lt;body&gt;&lt;h1&gt;Title&lt;/h1&gt;&lt;/body&gt;&lt;/html&gt;&quot;","ref":"Premailex.HTMLParser.html#to_string/1","title":"Premailex.HTMLParser.to_string/1","type":"function"},{"doc":"","ref":"Premailex.HTMLParser.html#c:to_string/1","title":"Premailex.HTMLParser.to_string/1","type":"callback"},{"doc":"","ref":"Premailex.HTMLParser.html#t:html_tree/0","title":"Premailex.HTMLParser.html_tree/0","type":"type"},{"doc":"","ref":"Premailex.HTMLParser.html#t:selector/0","title":"Premailex.HTMLParser.selector/0","type":"type"},{"doc":"Module that converts HTML emails to plain text.","ref":"Premailex.HTMLToPlainText.html","title":"Premailex.HTMLToPlainText","type":"module"},{"doc":"Processes HTML string into a plain text string.Examplesiex&gt; Premailex.HTMLToPlainText.process(&quot;&lt;html&gt;&lt;body&gt;&lt;ul&gt;&lt;li&gt;Test&lt;/li&gt;&lt;/ul&gt;&lt;/body&gt;&lt;/html&gt;&quot;) &quot;* Test&quot;","ref":"Premailex.HTMLToPlainText.html#process/1","title":"Premailex.HTMLToPlainText.process/1","type":"function"},{"doc":"HTTP adapter module for making http requests with httpc.SSL support will automatically be enabled if the :certifi and :ssl_verify_fun libraries exists in your project.","ref":"Premailex.HTTPAdapter.Httpc.html","title":"Premailex.HTTPAdapter.Httpc","type":"module"},{"doc":"Module that contains utility functions.","ref":"Premailex.Util.html","title":"Premailex.Util","type":"module"},{"doc":"Traverses tree searching for needle, and will call provided function on any occurances.If the function returns {:halt, any}, traverse will stop, and result will be {:halt, html_tree}.Examplesiex&gt; Premailex.Util.traverse({&quot;div&quot;, [], [{&quot;p&quot;, [], [&quot;First paragraph&quot;]}, {&quot;p&quot;, [], [&quot;Second paragraph&quot;]}]}, &quot;p&quot;, fn {name, attrs, _children} -&gt; {name, attrs, [&quot;Updated&quot;]} end) {&quot;div&quot;, [], [{&quot;p&quot;, [], [&quot;Updated&quot;]}, {&quot;p&quot;, [], [&quot;Updated&quot;]}]} iex&gt; Premailex.Util.traverse({&quot;div&quot;, [], [{&quot;p&quot;, [], [&quot;First paragraph&quot;]}, {&quot;p&quot;, [], [&quot;Second paragraph&quot;]}]}, {&quot;p&quot;, [], [&quot;Second paragraph&quot;]}, fn {name, attrs, _children} -&gt; {name, attrs, [&quot;Updated&quot;]} end) {&quot;div&quot;, [], [{&quot;p&quot;, [], [&quot;First paragraph&quot;]}, {&quot;p&quot;, [], [&quot;Updated&quot;]}]}","ref":"Premailex.Util.html#traverse/3","title":"Premailex.Util.traverse/3","type":"function"},{"doc":"Traverse all trees in array searching for needle, and will call function with element and number times needle has been found so far.Examplesiex&gt; Premailex.Util.traverse_reduce([{&quot;p&quot;, [], [&quot;First paragraph&quot;]}, {&quot;p&quot;, [], [&quot;Second paragraph&quot;]}], &quot;p&quot;, fn({name, attrs, _children}, acc) -&gt; {name, attrs, [&quot;Updated &quot; &lt;&gt; to_string(acc)]} end) {[{&quot;p&quot;, [], [&quot;Updated 0&quot;]}, {&quot;p&quot;, [], [&quot;Updated 1&quot;]}], 2}","ref":"Premailex.Util.html#traverse_reduce/3","title":"Premailex.Util.traverse_reduce/3","type":"function"},{"doc":"Traverses tree until first match for needle.Examplesiex&gt; Premailex.Util.traverse_until_first({&quot;div&quot;, [], [{&quot;p&quot;, [], [&quot;First paragraph&quot;]}, {&quot;p&quot;, [], [&quot;Second paragraph&quot;]}]}, &quot;p&quot;, fn {name, attrs, _children} -&gt; {name, attrs, [&quot;Updated&quot;]} end) {&quot;div&quot;, [], [{&quot;p&quot;, [], [&quot;Updated&quot;]}, {&quot;p&quot;, [], [&quot;Second paragraph&quot;]}]}","ref":"Premailex.Util.html#traverse_until_first/3","title":"Premailex.Util.traverse_until_first/3","type":"function"},{"doc":"","ref":"Premailex.Util.html#t:html_tree/0","title":"Premailex.Util.html_tree/0","type":"type"},{"doc":"","ref":"Premailex.Util.html#t:needle/0","title":"Premailex.Util.needle/0","type":"type"},{"doc":"Premailex Preflight for your HTML emails. Adds inline styling, and converts HTML to plain text.","ref":"readme.html","title":"Premailex","type":"extras"},{"doc":"Add inline CSS properties from &lt;style&gt;Add inline CSS properties from external &lt;link&gt; stylesheetsTransform HTML to plain text","ref":"readme.html#features","title":"Premailex - Features","type":"extras"},{"doc":"def deps do [ # ... {:premailex, &quot;~&gt; 0.3.0&quot;}, # Optional, but recommended for SSL validation with :httpc {:certifi, &quot;~&gt; 2.4&quot;}, {:ssl_verify_fun, &quot;~&gt; 1.1&quot;}, # ... ] endRun mix deps.get to install it.","ref":"readme.html#installation","title":"Premailex - Installation","type":"extras"},{"doc":"Transform an HTML string to text:Premailex.to_text(html)Add inline styles based on styles defined in &lt;head&gt;:Premailex.to_inline_css(html)","ref":"readme.html#getting-started","title":"Premailex - Getting started","type":"extras"},{"doc":"def welcome(user) do new() |&gt; to({user.name, user.email}) |&gt; from({&quot;Dr B Banner&quot;, &quot;hulk.smash@example.com&quot;}) |&gt; subject(&quot;Hello, Avengers!&quot;) |&gt; render_body(&quot;welcome.html&quot;, %{username: user.username}) |&gt; premail() end defp premail(email) do html = Premailex.to_inline_css(email.html_body) text = Premailex.to_text(email.html_body) email |&gt; html_body(html) |&gt; text_body(text) end","ref":"readme.html#example-with-swoosh","title":"Premailex - Example with Swoosh","type":"extras"},{"doc":"def welcome_email do new_email |&gt; subject(&quot;Email subject&quot;) |&gt; to(&quot;test@example.com&quot;) |&gt; from(&quot;test@example.com&quot;) |&gt; put_text_layout(false) |&gt; render(&quot;email.html&quot;) |&gt; premail() end defp premail(email) do html = Premailex.to_inline_css(email.html_body) text = Premailex.to_text(email.html_body) email |&gt; html_body(html) |&gt; text_body(text) end","ref":"readme.html#example-with-bamboo","title":"Premailex - Example with Bamboo","type":"extras"},{"doc":"By default, premailex uses Floki to parse HTML, but you can exchange it for any HTML parser you prefer. Meeseeks is supported with the Premailex.HTMLParser.Meeseeks module. To use it, add the following to config.exs:config :premailex, html_parser: Premailex.HTMLParser.Meeseeks","ref":"readme.html#html-parser","title":"Premailex - HTML parser","type":"extras"},{"doc":"Expand relative URL's","ref":"readme.html#planned-features","title":"Premailex - Planned features","type":"extras"},{"doc":"(The MIT License)Copyright (c) 2017-2019 Dan Schultzer &amp; the ContributorsPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"readme.html#license","title":"Premailex - LICENSE","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Premailex.HTMLInlineStyles.process/3 now supports passing in CSS as an argument","ref":"changelog.html#v0-3-12-2020-10-18","title":"Changelog - v0.3.12 (2020-10-18)","type":"extras"},{"doc":"Fixed bug where the inline styles where applied to more than the first match causing in some cases styles to be missing for subsequent parent elementsRelax floki requirementRelax meeseeks requirement","ref":"changelog.html#v0-3-11-2020-10-08","title":"Changelog - v0.3.11 (2020-10-08)","type":"extras"},{"doc":"Support floki up to v0.24.x","ref":"changelog.html#v0-3-10-2020-01-09","title":"Changelog - v0.3.10 (2020-01-09)","type":"extras"},{"doc":"Ignore @font-face at-rule","ref":"changelog.html#v0-3-9-2019-10-06","title":"Changelog - v0.3.9 (2019-10-06)","type":"extras"},{"doc":"Removed HTTPoison and use :httpc insteadFixed bug where HTML with no style tags resulted in all existing inline styles being removedAdded is_binary/1 guard to Premailex.to_inline_css/2 and Premailex.to_text/1","ref":"changelog.html#v0-3-8-2019-08-22","title":"Changelog - v0.3.8 (2019-08-22)","type":"extras"},{"doc":"Preserve downlevel-revealed conditional comments in Premailex.Util.traverse/3","ref":"changelog.html#v0-3-7-2019-07-05","title":"Changelog - v0.3.7 (2019-07-05)","type":"extras"},{"doc":"Preserve conditional comments in Premailex.Util.traverse/3 so they can show up in output from Premailex.HTMLInlineStyles.process/2","ref":"changelog.html#v0-3-6-2019-06-22","title":"Changelog - v0.3.6 (2019-06-22)","type":"extras"},{"doc":"Accept &lt;table&gt; with &lt;th&gt; elements.","ref":"changelog.html#v0-3-5-2019-03-21","title":"Changelog - v0.3.5 (2019-03-21)","type":"extras"},{"doc":"HTTP adapter for HTTPoison that handles redirects #31 #32 (thanks Przemyslaw Mroczek @Lackoftactics)","ref":"changelog.html#v0-3-4","title":"Changelog - v0.3.4","type":"extras"},{"doc":"Ignore @media queries #28 #29","ref":"changelog.html#v0-3-3","title":"Changelog - v0.3.3","type":"extras"},{"doc":"Remove bypass for tests and make http adapter configurable #27Test with updated dependencies #26","ref":"changelog.html#v0-3-2","title":"Changelog - v0.3.2","type":"extras"},{"doc":"Handle url values in css rules correctly #25","ref":"changelog.html#v0-3-1","title":"Changelog - v0.3.1","type":"extras"},{"doc":"Meeseeks v0.8.0 no longer supported #23Ensure Elixir 1.7 support #22","ref":"changelog.html#v0-3-0","title":"Changelog - v0.3.0","type":"extras"}]